VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CPrintListView"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'==============================================================================
'Druckt ein ListView.
'Code wurde inspiriert von Marco Losavio, wurde aber zu einem groen Teil
'selbst verndert und verbessert.
'
'Scope:     DLL-ffentlich erstellbar.
'==============================================================================

Option Explicit

Event BeforeNewPage()

Private m_Control As ListView
Private m_Page As CPage
Private m_Title As CText
Private m_PrintOnlySelectedItems As Boolean
Private m_PrintedItems As Long
Private m_HeaderFont As StdFont
Private m_FontItem As StdFont

Public Property Get HeaderFont() As StdFont
    Set HeaderFont = m_HeaderFont
End Property

Public Property Get PrintedItems() As Long
    PrintedItems = m_PrintedItems
End Property

Public Property Get PrintOnlySelectedItems() As Boolean
    PrintOnlySelectedItems = m_PrintOnlySelectedItems
End Property
Public Property Let PrintOnlySelectedItems(ByVal nv As Boolean)
    m_PrintOnlySelectedItems = nv
End Property

Public Property Get Title() As CText
    Set Title = m_Title
End Property

Public Property Set Title(Title As CText)
    Set m_Title = Title
End Property

Public Property Get Page() As CPage
    Set Page = m_Page
End Property

Public Property Set Page(Page As CPage)
    Set m_Page = Page
End Property

Public Property Get Control() As ListView
    Set Control = m_Control
End Property
Public Property Set Control(nv As ListView)
    Set m_Control = nv
    With m_FontItem
        .Name = nv.Font.Name
        .Size = nv.Font.Size
        .Bold = nv.Font.Bold
        .Italic = nv.Font.Italic
        .Strikethrough = nv.Font.Strikethrough
        .Underline = nv.Font.Underline
    End With
    With m_HeaderFont
        .Name = nv.Font.Name
        .Size = nv.Font.Size
        .Bold = nv.Font.Bold
        .Italic = nv.Font.Italic
        .Strikethrough = nv.Font.Strikethrough
        .Underline = nv.Font.Underline
    End With
    
End Property


Private Sub Class_Initialize()
    Set m_Page = New CPage
    Set m_Title = New CText
    Set m_HeaderFont = New StdFont
    Set m_FontItem = New StdFont
End Sub

Private Sub Class_Terminate()
    Set m_Page = Nothing
    Set m_Title = Nothing
    Set m_Control = Nothing
    Set m_HeaderFont = Nothing
    Set m_FontItem = Nothing
End Sub


' The FontItem property

Public Property Get FontItem() As StdFont
    Set FontItem = m_FontItem
End Property

Public Property Set FontItem(Font As StdFont)
    Set m_FontItem = Font
End Property


Public Function PrintControl(ByVal InColor As Boolean, ByVal Mark As Boolean) As Boolean
Dim itmX As ListItem, i As Long

    On Error GoTo ErrPrintLV
    SetPage m_Page
    
    Printer.Print " "
    
    RaiseEvent BeforeNewPage
    Printer.CurrentY = m_Page.TopMargin * vbCM - Printer.TextHeight(m_Page.Header.Text)
    
    PrintCText m_Page.Header, _
               m_Page.LeftMargin * vbCM, _
               m_Page.RightMargin * vbCM
                
    Printer.CurrentX = m_Page.LeftMargin * vbCM
    Printer.CurrentY = m_Page.TopMargin * vbCM + IIf(m_Page.Header.Text <> "", 20 * Screen.TwipsPerPixelY, 0)
    
        
    
    If m_Title.Text <> "" Then
        PrintCText m_Title, m_Page.LeftMargin * vbCM, m_Page.RightMargin * vbCM
        
        Printer.CurrentY = Printer.CurrentY + 20 * Screen.TwipsPerPixelY
    End If
    
    SetPrinterFont m_HeaderFont
    PrintHeaderLV m_Control, m_Page.LeftMargin * vbCM  ', m_Page.RightMargin * vbCM
    SetPrinterFont m_FontItem
    m_PrintedItems = 0
    For i = 1 To m_Control.ListItems.Count
        Set itmX = m_Control.ListItems(i)
        If (m_PrintOnlySelectedItems And itmX.Selected) Or _
            (Not m_PrintOnlySelectedItems) Then
            If Not CanPrintItem(Printer.TextHeight(itmX.Text) + 2 * Printer.TwipsPerPixelY, _
                                m_Page.BottomMargin * vbCM + IIf(m_Page.Footer.Text <> "", 20 * Screen.TwipsPerPixelY, 0)) Then
                
                Printer.CurrentY = Printer.ScaleHeight - m_Page.BottomMargin * vbCM
                
                PrintCText m_Page.Footer, _
                            m_Page.LeftMargin * vbCM, _
                            m_Page.RightMargin * vbCM
                            
                RaiseEvent BeforeNewPage
                Printer.NewPage
                
                Printer.CurrentY = m_Page.TopMargin * vbCM - Printer.TextHeight(m_Page.Header.Text)
                
                PrintCText m_Page.Header, _
                            m_Page.LeftMargin * vbCM, _
                            m_Page.RightMargin * vbCM
                
                SetPrinterFont m_HeaderFont
                
                Printer.CurrentY = m_Page.TopMargin * vbCM + IIf(m_Page.Header.Text <> "", 20 * Screen.TwipsPerPixelY, 0)
                
                PrintHeaderLV m_Control, _
                                     m_Page.LeftMargin * vbCM ', _
                                     m_Page.RightMargin * vbCM
                                     
                SetPrinterFont m_FontItem
                        
            End If
            
            PrintItemLV itmX, m_Control, _
                         m_Page.LeftMargin * vbCM, InColor, Mark
                         
            m_PrintedItems = m_PrintedItems + 1
        End If
    Next i
    
    Printer.CurrentY = Printer.ScaleHeight - m_Page.BottomMargin * vbCM
    
    PrintCText m_Page.Footer, _
                m_Page.LeftMargin * vbCM, _
                m_Page.RightMargin * vbCM
                
    Printer.EndDoc
    PrintControl = True
    
    Exit Function
    
ErrPrintLV:
    Printer.KillDoc
    Beep
    MsgBox Err.Number & " " & Err.Description, vbExclamation
End Function

