VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsLVTextExport"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'==============================================================================
'Kapselt den Export eines ListView in eine Textdatei ab.
'
'Scope:     DLL-ffentlich erstellbar.
'==============================================================================


Option Explicit

Dim MyListView As ListView 'Zu exportierendes ListView

'Export-Ziel-Dateiname, Titel
Dim mFilename As String, mHeader As String

'Nur ausgewhlte Eintrge exportieren, Spalten-Header exportieren, An Textdatei anhngen, lesbare Textdatei erstellen
Dim mOnlySelected As Boolean, mWriteHeader As Boolean, mAppend As Boolean, mReadable As Boolean

'Setzt das zu exportierende ListView.
Property Let ListView(ListView As Object)
    Set MyListView = ListView
End Property

'==============================================================================
'Zweck:     Zeigt den Dialog zum Auswhlen eines Exportziels (Datei) an.
'
'Rckgabe:  True, falls der Dialog besttigt wurde, sonst False.
'==============================================================================
Function ShowFileDialog() As Boolean
    With New frmCDialogDummy
        With .cdialog
            .Flags = cdlOFNOverwritePrompt
            .Filter = "Textdateien (*.txt)|*.txt|Alle Dateien (*.*)|*.*"
            .DialogTitle = "Exportziel auswhlen"
            .DefaultExt = "*.txt"
            .Filename = mFilename
            On Error GoTo erro
            .ShowSave
            mFilename = .Filename
            ShowFileDialog = True
erro:
        End With
    End With
End Function

'Die folgenden Eigenschaften ermglichen das Auslesen bzw. Setzen der
'Export-Attribute.

Property Get Filename() As String
    Filename = mFilename
End Property

Property Let Filename(ByVal value As String)
    mFilename = value
End Property

Property Get Header() As String
    Header = mHeader
End Property

Property Let Header(ByVal value As String)
    mHeader = value
End Property

Property Get OnlySelected() As Boolean
    OnlySelected = mOnlySelected
End Property

Property Let OnlySelected(ByVal value As Boolean)
    mOnlySelected = value
End Property

Property Get WriteHeader() As Boolean
    WriteHeader = mWriteHeader
End Property

Property Let WriteHeader(ByVal value As Boolean)
    mWriteHeader = value
End Property

Property Get Append() As Boolean
    Append = mAppend
End Property

Property Let Append(ByVal value As Boolean)
    mAppend = value
End Property

Property Get Readable() As Boolean
    Readable = mReadable
End Property

Property Let Readable(ByVal value As Boolean)
    mReadable = value
End Property

'==============================================================================
'Zweck:     Exportiert das zurvor angegebenen ListView mit den zuvor
'           angegebenen Attributen in eine Textdatei.
'
'Rckgabe:  True, falls der Vorgang erfolgreich war, sonst False.
'==============================================================================
Function ExportListViewToTextfile() As Boolean
    On Error GoTo erro
    Dim i As Long, j As Long, DN As Byte
    
    DN = FreeFile
    
    If mAppend Then
        Open mFilename For Append As DN
    Else
        Open mFilename For Output As DN
    End If
    
    
    Dim maxLength() As Long
    
    If mReadable Then
        ReDim maxLength(MyListView.ColumnHeaders.Count - 1)
        
        For i = 1 To MyListView.ColumnHeaders.Count
            maxLength(i - 1) = Len(MyListView.ColumnHeaders(i).Text)
        Next i
        
        For i = 1 To MyListView.ListItems.Count
            If maxLength(0) < Len(MyListView.ListItems(i).Text) Then
                maxLength(0) = Len(MyListView.ListItems(i).Text)
            End If
            
            For j = 1 To MyListView.ColumnHeaders.Count - 1
                If maxLength(j) < Len(MyListView.ListItems(j).SubItems(j)) Then
                    maxLength(j) = Len(MyListView.ListItems(j).SubItems(j))
                End If
            Next j
        Next i
    
        For i = 1 To MyListView.ColumnHeaders.Count - 1
            maxLength(i - 1) = maxLength(i - 1) + 1
        Next i
    End If
    
    Dim strLine As String
    
    strLine = ""
   
    If mHeader <> "" Then
        Print #DN, mHeader
        Print #DN, String$(Len(mHeader), "=")
        Print #DN, ""
    End If
   
   
    If mWriteHeader Then
        For i = 1 To MyListView.ColumnHeaders.Count
            strLine = strLine & MyListView.ColumnHeaders(i).Text
            
            If mReadable Then
                strLine = strLine & String$(maxLength(i - 1) - Len(MyListView.ColumnHeaders(i).Text), " ")
            Else
                strLine = strLine & vbTab
            End If
        Next i
        Print #DN, Trim$(strLine)
        Print #DN, String$(Len(strLine), "-")
    End If
    
    
    For i = 1 To MyListView.ListItems.Count
        'Falls dieses Item ausgegeben werden soll.
        If (OnlySelected And MyListView.ListItems(i).Selected) Or Not OnlySelected Then
            strLine = MyListView.ListItems(i).Text
            If mReadable Then
                strLine = strLine & String$(maxLength(0) - Len(MyListView.ListItems(i).Text), " ")
            Else
                strLine = strLine & vbTab
            End If
            
            'Alle Spalten durchlaufen
            For j = 1 To MyListView.ColumnHeaders.Count - 1
                strLine = strLine & MyListView.ListItems(i).SubItems(j)
                
                If mReadable Then
                    strLine = strLine & String(maxLength(j) - Len(MyListView.ListItems(i).SubItems(j)), " ")
                Else
                    strLine = strLine & vbTab
                End If
            Next j
            Print #DN, Trim$(strLine)
        End If
    Next i
                
                
    ExportListViewToTextfile = True
    Close #DN
    Exit Function
    
erro:
    Close #DN
    MsgBox "Fehler " & Err.Number & " beim Exportieren in Textdatei aufgetreten:" & vbCrLf & vbCrLf & Err.Description, vbCritical, "Liste exportieren"
End Function

Private Sub Class_Initialize()
    mWriteHeader = True
    mReadable = True
End Sub
